/*
 * Joey and its relative products are published under the terms
 * of the Apache Software License.
 */
/*
 * Created on 2004/01/27
 */
package org.asyrinx.joey.gen.model;

import org.apache.commons.lang.builder.EqualsBuilder;

/**
 * @author akima
 */
public class EnumerationEntry extends Element {

    /**
     *  
     */
    public EnumerationEntry() {
        super();
    }

    /**
     *  
     */
    public EnumerationEntry(AbstractEnumeration parent, String name, String label) {
        this(parent, null, name, label);
    }

    /**
     *  
     */
    public EnumerationEntry(AbstractEnumeration parent, String value, String name, String label) {
        super(parent, name, label);
        this.value = value;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.asyrinx.joey.gen.model.Element#getParentElement()
     */
    public AbstractEnumeration getParent() {
        return (AbstractEnumeration) super.getParentElement();
    }

    private String value = null;

    /**
     * @return Returns the value.
     */
    public String getValue() {
        return value;
    }

    /**
     * @param value
     *            The value to set.
     */
    public void setValue(String value) {
        this.value = value;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object obj) {
        if (!super.equals(obj))
            return false;
        if (!(obj instanceof EnumerationEntry))
            return false;
        final EnumerationEntry other = (EnumerationEntry) obj;
        return new EqualsBuilder() //
                .append(this.getValue(), other.getValue()) //
                .isEquals();
    }

}