/*
 * joey-gen and its relative products are published under the terms
 * of the Apache Software License.
 * 
 * Created on 2004/11/07 21:25:09
 */
package org.asyrinx.joey.gen.model.java;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.asyrinx.joey.gen.model.Element;
import org.asyrinx.joey.gen.model.ElementSet;

/**
 * @author takeshi
 */
public class EntityKeySet extends ElementSet {

    /**
     * @param parent
     */
    public EntityKeySet(Element parent) {
        super(parent);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.asyrinx.joey.gen.model.Element#isEntity()
     */
    public boolean isEntity() {
        return false;
    }

    public void add(EntityKey key) {
        super.add(key);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.asyrinx.joey.gen.model.ElementSet#contains(org.asyrinx.joey.gen.model.Element)
     */
    public boolean contains(EntityKey key) {
        return super.contains(key);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.asyrinx.joey.gen.model.ElementSet#getElement(int)
     */
    public EntityKey getKey(int index) {
        return (EntityKey) super.getElement(index);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.asyrinx.joey.gen.model.ElementSet#get(java.lang.String)
     */
    public EntityKey getKey(String name) {
        return (EntityKey) super.getElement(name);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.asyrinx.joey.gen.model.ElementSet#remove(java.lang.String)
     */
    public EntityKey removeKey(String name) {
        return (EntityKey) super.removeElement(name);
    }

    /**
     * @return
     */
    public EntityKey getPrimaryKey() {
        for (Iterator i = this.iterator(); i.hasNext();) {
            final EntityKey key = (EntityKey) i.next();
            if (key.isPrimaryKey())
                return key;
        }
        return null;
    }

    public List getIndexes() {
        return getKeys(EntityKeyType.INDEX);
    }

    public List getUniques() {
        return getKeys(EntityKeyType.UNIQUE);
    }

    /**
     * @param type
     * @return
     */
    private List getKeys(final EntityKeyType type) {
        final List result = new ArrayList();
        for (Iterator i = this.iterator(); i.hasNext();) {
            final EntityKey key = (EntityKey) i.next();
            if (key.getKeyType() == type)
                result.add(key);
        }
        return result;
    }
}